/*
 *      Copyright (C) 2009, David Delassus <linkdd62@gmail.com>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef __CREAM_VIEW_H
#define __CREAM_VIEW_H

#include <gtk/gtk.h>
#include <webkit/webkit.h>

typedef enum { HideCompletion, DirectionPrev, DirectionNext } CompletionArg;

typedef struct
{
    GtkWidget *eventbox;
    GtkWidget *status_url;
    GtkWidget *status_state;
} Statusbar;

typedef struct
{
    GtkWidget *viewport;
    GtkAdjustment *adjust_v;
    GtkAdjustment *adjust_h;
} Scrollbar;

typedef struct
{
    GtkWidget *box;
    GtkWidget *webview;
    Scrollbar scroll;
    Statusbar statusbar;
    GtkWidget *command_line;
} CreamView;

CreamView *cream_view_new (void);
void cream_view_update_state (CreamView *obj, gint frac);
void cream_view_update_url (CreamView *obj, const gchar *url, gboolean link);
void cream_view_load_ftp (CreamView *view, const gchar *uri);
void cream_view_script (CreamView *obj, const gchar *script);
void cream_view_complete (CreamView *obj, CompletionArg arg);
void echo (CreamView *obj, const gchar *fmt, ...);

#endif /* __CREAM_VIEW_H */
