/*
 *      Copyright (C) 2009, David Delassus <linkdd62@gmail.com>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef __BOOKMARKS_H
#define __BOOKMARKS_H

typedef struct
{
    gchar *uri;
    gchar *title;
} BookmarksItem;

void bookmarks_read_file (void);
void bookmarks_write_file (void);
void bookmarks_add_item (const gchar *uri, const gchar *title);
void bookmarks_delete_item (const gchar *uri, const gchar *title);
void bookmarks_modify_item (int i, const gchar *new_uri, const gchar *new_title);
void show_bookmarks (void);

#endif /* __BOOKMARKS_H */
