/*
 *      Copyright (C) 2009, David Delassus <linkdd62@gmail.com>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef __CALLBACKS_H
#define __CALLBACKS_H

void webview_title_changed_cb ( WebKitWebView *webview,
                                WebKitWebFrame *frame,
                                gchar *title,
                                gpointer user_data);

void webview_progress_changed_cb (  WebKitWebView *webview,
                                    gint progress,
                                    gpointer user_data);

void webview_load_committed_cb (WebKitWebView *webview,
                                WebKitWebFrame *frame,
                                gpointer user_data);

void webview_load_finished_cb ( WebKitWebView *webview,
                                WebKitWebFrame *frame,
                                gpointer user_data);

WebKitNavigationResponse webview_navigation_cb (
                                        WebKitWebView *web_view,
                                        WebKitWebFrame *frame,
                                        WebKitNetworkRequest *request,
                                        gpointer data);

WebKitWebView *webview_new_window_cb (  WebKitWebView *webview,
                                        WebKitWebFrame *frame,
                                        gpointer user_data);

gboolean webview_mimetype_cb (  WebKitWebView *webview,
                                WebKitWebFrame *frame,
                                WebKitNetworkRequest *request,
                                gchar *mime_type,
                                WebKitWebPolicyDecision *decision,
                                gpointer user_data);

gboolean webview_download_cb (  WebKitWebView *webview,
                                WebKitDownload *download,
                                gpointer user_data);

void webview_hoverlink_cb ( WebKitWebView *webview,
                            gchar *title,
                            gchar *link,
                            gpointer data);

gboolean webview_console_cb (   WebKitWebView *webview,
                                gchar *message,
                                gint line,
                                gchar *source,
                                gpointer user_data);

void webview_populate_menu_cb ( WebKitWebView *web_view,
                                GtkMenu *menu,
                                gpointer data);

void webview_scroll_cb (GtkAdjustment *adjustment,
                        gpointer user_data);

void notebook_close_page_cb (GtkWidget *widget, gpointer data);

WebKitWebView *create_inspect_win_cb (  WebKitWebInspector *web_inspector,
                                        WebKitWebView *web_view,
                                        gpointer data);

gboolean inputbox_key_press_cb (GtkWidget *widget,
                                GdkEventKey *event,
                                gpointer data);

gboolean window_key_press ( GtkWidget *widget,
                            GdkEventKey *event,
                            gpointer data);

void notebook_page_added_cb (   GtkNotebook *notebook,
                                GtkWidget *child,
                                guint page_num,
                                gpointer user_data);

void notebook_page_removed_cb ( GtkNotebook *notebook,
                                GtkWidget *child,
                                guint page_num,
                                gpointer user_data);

void notebook_page_reordered_cb (   GtkNotebook *notebook,
                                    GtkWidget *child,
                                    guint page_num,
                                    gpointer user_data);

void notebook_switch_page_cb (  GtkNotebook *notebook,
                                GtkWidget *child,
                                guint page_num,
                                gpointer user_data);

void print_page_cb (GtkWidget *widget, gpointer data);
void bookmark_cb (GtkWidget *widget, gpointer data);

#endif /* __CALLBACKS_H */
