/*
 *      Copyright (C) 2009, David Delassus <linkdd62@gmail.com>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef __COMMAND_H
#define __COMMAND_H

typedef struct
{
    gchar *id;
    gchar *cmd;
    gint n_args;
    void (*func) (gint argc, gchar **argv);
    gchar *desc;
} Command;

gchar *get_command (const gchar *identifier);
void set_desc (const gchar *identifier, const gchar *desc);
void input_activate_cb (GtkWidget *widget, gpointer data);
void getcmd (GtkWidget *entry, const gchar *text);
void cmd_open (gint argc, gchar **argv);
void cmd_tabopen (gint argc, gchar **argv);
void cmd_close (gint argc, gchar **argv);
void cmd_quit (gint argc, gchar **argv);
void cmd_search (gint argc, gchar **argv);
void cmd_yank (gint argc, gchar **argv);
void cmd_paste (gint argc, gchar **argv);
void cmd_trash (gint argc, gchar **argv);
void cmd_hist (gint argc, gchar **argv);
void cmd_book (gint argc, gchar **argv);

#endif /* __COMMAND_H */
