#!/bin/env perl -w
use strict;

my $js;
open(JSFILE, "script.js") or die "Failed to open file: $!";
$_ = do { local $/; <JSFILE> };
close(JSFILE);
s/\t|\r|\n/ /g;     # convert spacings to whitespaces
s/\/\*.*?\*\///g;   # remove comments
s/ {2,}/ /g;        # strip whitespaces
s/(^|\(|\)|;|,|:|\}|\{|=|\+|\-|\*|\&|\||\<|\>|!) +/$1/g;
s/ +($|\(|\)|;|,|:|\}|\{|=|\+|\-|\*|\&|\||\<|\>|!)/$1/g;
s/\\/\\\\/g;        # escape backslashes
s/\"/\\\"/g;        # escape quotes
$js = $_;

open(CFILE, "html.h.in") or die "Failed to open html.h.in: $!";
$_ = do { local $/; <CFILE> };
close(CFILE);

s/(#define JS_SETUP)/$1 "$js"/;

open(CFILE, ">html.h") or die "Failed to open html.h for writing: $!";
print CFILE $_;
close(CFILE);
