/*
 *      Copyright (C) 2009, David Delassus <linkdd62@gmail.com>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef __HISTORY_H
#define __HISTORY_H

typedef struct
{
    time_t timestamp;
    gchar *uri;
    gchar *title;
} HistoryItem;

void history_read_file (void);
void history_write_file (void);
void history_add_item (const gchar *uri, const gchar *title);
void history_delete_item (const gchar *uri, const gchar *title);
void show_history (void);

#endif /* __HISTORY_H */
