/*
 *      Copyright (C) 2009, David Delassus <linkdd62@gmail.com>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef __KEYBINDING_H
#define __KEYBINDING_H

typedef enum
{
    NoArguments,
    InputMode,
    ViewMode,
    HintsMode,
    CaretMode,
    InsertCurrentURL,
    RefreshByPassCache,
    ZoomIn,
    ZoomOut,
    Tabopen
} Arg;

typedef struct
{
    gchar *id;
    guint modmask;
    guint modkey;
    guint key;
    void (*func) (CreamView *obj, Arg arg);
    Arg argument;
} Keybinding;

void path_to_key (const gchar *path, guint *modmask, guint *modkey, guint *key);
void key_switch (CreamView *obj, Arg arg);
void key_previous (CreamView *obj, Arg arg);
void key_open (CreamView *obj, Arg arg);
void key_tabopen (CreamView *obj, Arg arg);
void key_close (CreamView *obj, Arg arg);
void key_refresh (CreamView *obj, Arg arg);
void key_zoom (CreamView *obj, Arg arg);
void key_yank (CreamView *obj, Arg arg);
void key_paste (CreamView *obj, Arg arg);
void key_quit (CreamView *obj, Arg arg);

#endif /* __KEYBINDING_H */
