/* -- INSERT -- */
function clear_focus ()
{
    if (document.activeElement && document.activeElement.blur)
    {
        document.activeElement.blur();
    }
}

function log_insertmode (element, focus)
{
    var name = element.nodeName.toLowerCase ();

    if ((name == 'input' && /^(text|password)$/.test (element.type))
        || /^(select|textarea)$/.test (name)
        || element.contentEditable == 'true')
    {
        console.log ('insertmode_' + (focus == 'focus' ? 'on' : 'off'));
    }
}

if (document.activeElement)
{
    log_insertmode (document.activeElement, 'focus');
}

m = [ 'focus', 'blur' ];

for (i in m)
{
    document.getElementsByTagName ('body')[0].addEventListener (m[i], function (x)
    {
        log_insertmode (x.target, x.type);
    }, true);
}

/* -- HINTS -- */

document.getElementsByTagName ("body")[0].appendChild (document.createElement ("style"));
document.styleSheets[0].addRule ('.hinting_mode_hint', 'color: #000; background: #ff0');
document.styleSheets[0].addRule ('.hinting_mode_hint_focus', 'color: #000; background: #8f0');

function show_hints ()
{
    var tags = "//html:*[@onclick or @onmouseover or @onmousedown or @oncommand or @class='lk' or @role='link'] | //html:input[not(@type='hidden')] | //html:a | //html:area | //html:iframe | //html:textarea | //html:button | //html:select";
    var list = document.evaluate (tags, document, function(p) {
            return "http://www.w3.org/1999/xhtml";
        }, XPathResult.ORDERER_NODE_ITERATOR_TYPE, null);

    a = [];
    b = [];

    for (var i = 1; element = list.iterateNext (); ++i)
    {
        var hint = document.createElement ("div");
        hint.setAttribute ('id', 'hint' + i);
        hint.innerHTML = i;
        hint.style.display = 'inline';
        hint.style.lineHeight = '90%';
        hint.style.backgroundColor = 'red';
        hint.style.color = 'white';
        hint.style.fontSize = 'small-xx';
        hint.style.fontWeight = 'light';
        hint.style.margin = '0px';
        hint.style.padding = '2px';
        hint.style.position = 'absolute';
        hint.style.textDecoration = 'none';
        hint.style.left = element.style.left;
        hint.style.top = element.style.top;
        element.insertAdjacentElement ('afterBegin', hint);
        element.className += ' hinting_mode_hint';

        a.push (element);
        b.push (hint);
    }

    clear_focus ();

    console.log ('hintmode_on');
}

function hide_hints ()
{
    for (e in a)
    {
        a[e].className = a[e].className.replace (/hinting_mode_hint/,'');
        a[e].removeChild (b[e]);
    }

    console.log ('hintmode_off');
}
